"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.renderServer = exports.render = exports.readPageHtml = exports.checkModules = void 0;
var _fs = require("fs");
var _serverRenderer = require("@vue/server-renderer");
var _serializeJavascript = require("serialize-javascript");
var _vue3Webpack = require("@srejs/vue3-webpack");
var _common = _interopRequireWildcard(require("@srejs/common"), true);
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _regeneratorRuntime() { "use strict"; /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */ _regeneratorRuntime = function _regeneratorRuntime() { return exports; }; var exports = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, defineProperty = Object.defineProperty || function (obj, key, desc) { obj[key] = desc.value; }, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag"; function define(obj, key, value) { return Object.defineProperty(obj, key, { value: value, enumerable: !0, configurable: !0, writable: !0 }), obj[key]; } try { define({}, ""); } catch (err) { define = function define(obj, key, value) { return obj[key] = value; }; } function wrap(innerFn, outerFn, self, tryLocsList) { var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context = new Context(tryLocsList || []); return defineProperty(generator, "_invoke", { value: makeInvokeMethod(innerFn, self, context) }), generator; } function tryCatch(fn, obj, arg) { try { return { type: "normal", arg: fn.call(obj, arg) }; } catch (err) { return { type: "throw", arg: err }; } } exports.wrap = wrap; var ContinueSentinel = {}; function Generator() {} function GeneratorFunction() {} function GeneratorFunctionPrototype() {} var IteratorPrototype = {}; define(IteratorPrototype, iteratorSymbol, function () { return this; }); var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([]))); NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype); var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype); function defineIteratorMethods(prototype) { ["next", "throw", "return"].forEach(function (method) { define(prototype, method, function (arg) { return this._invoke(method, arg); }); }); } function AsyncIterator(generator, PromiseImpl) { function invoke(method, arg, resolve, reject) { var record = tryCatch(generator[method], generator, arg); if ("throw" !== record.type) { var result = record.arg, value = result.value; return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) { invoke("next", value, resolve, reject); }, function (err) { invoke("throw", err, resolve, reject); }) : PromiseImpl.resolve(value).then(function (unwrapped) { result.value = unwrapped, resolve(result); }, function (error) { return invoke("throw", error, resolve, reject); }); } reject(record.arg); } var previousPromise; defineProperty(this, "_invoke", { value: function value(method, arg) { function callInvokeWithMethodAndArg() { return new PromiseImpl(function (resolve, reject) { invoke(method, arg, resolve, reject); }); } return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg(); } }); } function makeInvokeMethod(innerFn, self, context) { var state = "suspendedStart"; return function (method, arg) { if ("executing" === state) throw new Error("Generator is already running"); if ("completed" === state) { if ("throw" === method) throw arg; return { value: void 0, done: !0 }; } for (context.method = method, context.arg = arg;;) { var delegate = context.delegate; if (delegate) { var delegateResult = maybeInvokeDelegate(delegate, context); if (delegateResult) { if (delegateResult === ContinueSentinel) continue; return delegateResult; } } if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) { if ("suspendedStart" === state) throw state = "completed", context.arg; context.dispatchException(context.arg); } else "return" === context.method && context.abrupt("return", context.arg); state = "executing"; var record = tryCatch(innerFn, self, context); if ("normal" === record.type) { if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue; return { value: record.arg, done: context.done }; } "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg); } }; } function maybeInvokeDelegate(delegate, context) { var methodName = context.method, method = delegate.iterator[methodName]; if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel; var record = tryCatch(method, delegate.iterator, context.arg); if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel; var info = record.arg; return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel); } function pushTryEntry(locs) { var entry = { tryLoc: locs[0] }; 1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry); } function resetTryEntry(entry) { var record = entry.completion || {}; record.type = "normal", delete record.arg, entry.completion = record; } function Context(tryLocsList) { this.tryEntries = [{ tryLoc: "root" }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0); } function values(iterable) { if (iterable || "" === iterable) { var iteratorMethod = iterable[iteratorSymbol]; if (iteratorMethod) return iteratorMethod.call(iterable); if ("function" == typeof iterable.next) return iterable; if (!isNaN(iterable.length)) { var i = -1, next = function next() { for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next; return next.value = undefined, next.done = !0, next; }; return next.next = next; } } throw new TypeError(_typeof(iterable) + " is not iterable"); } return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", { value: GeneratorFunctionPrototype, configurable: !0 }), defineProperty(GeneratorFunctionPrototype, "constructor", { value: GeneratorFunction, configurable: !0 }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) { var ctor = "function" == typeof genFun && genFun.constructor; return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name)); }, exports.mark = function (genFun) { return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun; }, exports.awrap = function (arg) { return { __await: arg }; }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () { return this; }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) { void 0 === PromiseImpl && (PromiseImpl = Promise); var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl); return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) { return result.done ? result.value : iter.next(); }); }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () { return this; }), define(Gp, "toString", function () { return "[object Generator]"; }), exports.keys = function (val) { var object = Object(val), keys = []; for (var key in object) keys.push(key); return keys.reverse(), function next() { for (; keys.length;) { var key = keys.pop(); if (key in object) return next.value = key, next.done = !1, next; } return next.done = !0, next; }; }, exports.values = values, Context.prototype = { constructor: Context, reset: function reset(skipTempReset) { if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined); }, stop: function stop() { this.done = !0; var rootRecord = this.tryEntries[0].completion; if ("throw" === rootRecord.type) throw rootRecord.arg; return this.rval; }, dispatchException: function dispatchException(exception) { if (this.done) throw exception; var context = this; function handle(loc, caught) { return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught; } for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i], record = entry.completion; if ("root" === entry.tryLoc) return handle("end"); if (entry.tryLoc <= this.prev) { var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc"); if (hasCatch && hasFinally) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } else if (hasCatch) { if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0); } else { if (!hasFinally) throw new Error("try statement without catch or finally"); if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc); } } } }, abrupt: function abrupt(type, arg) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) { var finallyEntry = entry; break; } } finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null); var record = finallyEntry ? finallyEntry.completion : {}; return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record); }, complete: function complete(record, afterLoc) { if ("throw" === record.type) throw record.arg; return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel; }, finish: function finish(finallyLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel; } }, "catch": function _catch(tryLoc) { for (var i = this.tryEntries.length - 1; i >= 0; --i) { var entry = this.tryEntries[i]; if (entry.tryLoc === tryLoc) { var record = entry.completion; if ("throw" === record.type) { var thrown = record.arg; resetTryEntry(entry); } return thrown; } } throw new Error("illegal catch attempt"); }, delegateYield: function delegateYield(iterable, resultName, nextLoc) { return this.delegate = { iterator: values(iterable), resultName: resultName, nextLoc: nextLoc }, "next" === this.method && (this.arg = undefined), ContinueSentinel; } }, exports; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
/**
 * 用Promise封装异步读取文件方法
 * @param  {string} page html文件名称
 * @return {promise}
 */
var readPageHtml = function readPageHtml(page) {
  return new Promise( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(resolve, reject) {
      var viewUrl, readFileSync, htmlString;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            viewUrl = "".concat(_common.clientDir, "/").concat(page, "/").concat(page, ".html");
            readFileSync = function readFileSync() {
              _fs.readFile(viewUrl, 'utf8', function (err, htmlString) {
                if (err) {
                  reject(err);
                  _common.Logger.error('SSR: The client code is being compiled, please refresh the browser later...');
                } else {
                  resolve(htmlString);
                }
              });
            };
            if (_common["default"].isDev()) {
              try {
                htmlString = _vue3Webpack.VueDevMiddlewareFileSystem.readFileSync(viewUrl, 'utf-8');
                resolve(htmlString);
              } catch (error) {
                readFileSync();
              }
            } else {
              readFileSync();
            }
          case 3:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());
};

/**
 *  生成环境编译代码检查
 * @param {*} page
 * @returns
 */
exports.readPageHtml = readPageHtml;
var checkModules = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(page) {
    var jspath, jsClientdir, compiler, _compiler;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          jspath = "".concat(_common.serverDir, "/").concat(page, "/").concat(page, ".js");
          jsClientdir = "".concat(_common.clientDir, "/").concat(page);
          if (_fs.existsSync(jspath)) {
            _context2.next = 6;
            break;
          }
          //服务端代码打包
          compiler = new _vue3Webpack.WebpackVue(page, _common["default"].isDev(), true);
          _context2.next = 6;
          return compiler.run();
        case 6:
          if (!(!_fs.existsSync(jsClientdir) && !_common["default"].isDev())) {
            _context2.next = 10;
            break;
          }
          //客户端代码打包
          _compiler = new _vue3Webpack.WebpackVue(page, _common["default"].isDev());
          _context2.next = 10;
          return _compiler.run();
        case 10:
          return _context2.abrupt("return", jspath);
        case 11:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return function checkModules(_x3) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * Router类型页面渲染解析
 * @param {*} ctx
 * @param {*} next
 */
exports.checkModules = checkModules;
var renderServer = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(ctx) {
    var initProps,
      ssr,
      context,
      _ctx$SSRKEY,
      page,
      query,
      path,
      options,
      Html,
      createApp,
      jspath,
      App,
      document,
      _args3 = arguments;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          initProps = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
          ssr = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : true;
          context = {
            url: ctx.req.url
          };
          _ctx$SSRKEY = ctx[_common.SSRKEY], page = _ctx$SSRKEY.page, query = _ctx$SSRKEY.query, path = _ctx$SSRKEY.path, options = _ctx$SSRKEY.options;
          query = (0, _common.filterXssByJson)(query);
          if ((0, _vue3Webpack.getVueEntryList)().has(page)) {
            _context3.next = 7;
            break;
          }
          return _context3.abrupt("return", "Page component ".concat(page, " does not exist, please check the pages folder"));
        case 7:
          if (_typeof(initProps) === 'object') {
            context = Object.assign({
              title: '',
              meta: ''
            }, context, initProps);
          }
          context.ssrData = {
            page: page,
            path: path,
            query: query,
            options: options
          };
          Html = '';
          if (!ssr) {
            _context3.next = 34;
            break;
          }
          _context3.next = 13;
          return checkModules(page);
        case 13:
          jspath = _context3.sent;
          try {
            // eslint-disable-next-line no-undef
            if (_common["default"].isDev()) {
              delete require.cache[require.resolve(jspath)];
            }
            createApp = require(jspath);
            createApp = createApp["default"] ? createApp["default"] : createApp;
          } catch (error) {
            // eslint-disable-next-line no-console
            _common.Logger.error("SSR: ".concat(page, "\u9875\u9762\u670D\u52A1\u7AEF\u52A0\u8F7D\u5165\u53E3\u6587\u4EF6\u5F02\u5E38\uFF0C\u8BF7\u68C0\u67E5\u662F\u5426\u5728\u4EE3\u7801\u7A0B\u5E8F\u4E2D\u4F7F\u7528\u5230\u6D4F\u89C8\u5668\u5BBF\u4E3B\u5BF9\u8C61\u7279\u5B9A\u7684API(\u5305\u62EC\u7B2C\u4E09\u65B9\u6A21\u5757\u9700\u652F\u6301SSR\u6A21\u5F0F\u5B89\u88C5)\n             Please check whether there are api in the code that the server does not support when rendering,\n             such as window, locaction, navigator, etc"));
            _common.Logger.error(error.stack);
          }
          _context3.prev = 15;
          _context3.next = 18;
          return createApp(context);
        case 18:
          App = _context3.sent;
          _context3.next = 21;
          return renderTostringVueNext(App, context, page);
        case 21:
          Html = _context3.sent;
          _context3.next = 32;
          break;
        case 24:
          _context3.prev = 24;
          _context3.t0 = _context3["catch"](15);
          ctx[_common.SSRKEY].options.ssr = false;
          context.ssrData = {
            page: page,
            path: path,
            query: query,
            options: options
          }; // 修正数据
          _common.Logger.warn("SSR: \u670D\u52A1\u7AEF\u6E32\u67D3\u5F02\u5E38\uFF0C\u964D\u7EA7\u4F7F\u7528\u5BA2\u6237\u7AEF\u6E32\u67D3:".concat(_context3.t0.stack));
          _context3.next = 31;
          return readPageString(page, context);
        case 31:
          Html = _context3.sent;
        case 32:
          _context3.next = 37;
          break;
        case 34:
          _context3.next = 36;
          return readPageString(page, context);
        case 36:
          Html = _context3.sent;
        case 37:
          document = (0, _common.renderDocumentHead)(Html, context);
          return _context3.abrupt("return", document);
        case 39:
        case "end":
          return _context3.stop();
      }
    }, _callee3, null, [[15, 24]]);
  }));
  return function renderServer(_x4) {
    return _ref3.apply(this, arguments);
  };
}();

/**
 * 客户端渲染时直接读取HTML注入变量
 * @param {*} page
 * @param {*} context
 * @returns
 */
exports.renderServer = renderServer;
var readPageString = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(page, context) {
    var temp;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          _context4.next = 2;
          return readPageHtml(page);
        case 2:
          temp = _context4.sent;
          return _context4.abrupt("return", injectScriptInitProps(temp, context));
        case 4:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return function readPageString(_x5, _x6) {
    return _ref4.apply(this, arguments);
  };
}();

/**
 * vue3.0 服务端渲染解析DOM
 * @param {*} App
 * @param {*} context
 * @param {*} page
 * @returns
 */
var renderTostringVueNext = /*#__PURE__*/function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(App, context, page) {
    var rootNode, html, appContent;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          rootNode = context.ssrData.options.rootNode;
          _context5.next = 3;
          return readPageString(page, context);
        case 3:
          html = _context5.sent;
          _context5.next = 6;
          return (0, _serverRenderer.renderToString)(App)["catch"](function (e) {
            console.log(e.stack);
          });
        case 6:
          appContent = _context5.sent;
          html = html.toString().replace("<div id=\"".concat(rootNode, "\">"), "<div id=\"".concat(rootNode, "\">").concat(appContent));
          return _context5.abrupt("return", html);
        case 9:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return function renderTostringVueNext(_x7, _x8, _x9) {
    return _ref5.apply(this, arguments);
  };
}();

/**
 * 在HTML中注入__SSR_DATA__
 * @param {*} temp
 * @param {*} context
 * @returns
 */
var injectScriptInitProps = function injectScriptInitProps(temp, context) {
  var contents = temp.split('</body>');
  if (contents.length == 1) {
    console.error('SSR:警告！vue3.0自定义html文件中必须包含</body>闭合标签。');
  }
  var data = Object.assign({}, context);
  var ssrData = data.ssrData;
  var initState = data.state;
  delete data.state;
  delete data.ssrData;
  delete context.ssrData;
  ssrData.initProps = data;
  return contents[0] + '<script>window.__INITIAL_STATE__=' + _serializeJavascript(initState, {
    isJSON: true
  }) + '</script>' + '<script>window.__SSR_DATA__=' + _serializeJavascript(ssrData, {
    isJSON: true
  }) + '</script>' + '</body>' + contents[1];
};
/**
 * 获取服务端渲染直出资源
 * @param {*} ctx
 */
var render = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee7(ctx, initProps) {
    var page, _ctx$SSRKEY$options, cache, ssr;
    return _regeneratorRuntime().wrap(function _callee7$(_context7) {
      while (1) switch (_context7.prev = _context7.next) {
        case 0:
          page = ctx[_common.SSRKEY].page;
          _ctx$SSRKEY$options = ctx[_common.SSRKEY].options, cache = _ctx$SSRKEY$options.cache, ssr = _ctx$SSRKEY$options.ssr;
          return _context7.abrupt("return", new Promise( /*#__PURE__*/function () {
            var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee6(resolve) {
              var ssrCacheDir, ssrCacheUrl, rs, document;
              return _regeneratorRuntime().wrap(function _callee6$(_context6) {
                while (1) switch (_context6.prev = _context6.next) {
                  case 0:
                    if (ssr) {
                      _context6.next = 6;
                      break;
                    }
                    _context6.t0 = resolve;
                    _context6.next = 4;
                    return renderServer(ctx, initProps, false);
                  case 4:
                    _context6.t1 = _context6.sent;
                    return _context6.abrupt("return", (0, _context6.t0)(_context6.t1));
                  case 6:
                    ssrCacheDir = "".concat(_common.cacheDir).concat(ctx.url, "/");
                    ssrCacheUrl = "".concat(_common.cacheDir).concat(ctx.url, "/").concat(page, ".html");
                    if (!(_common["default"].isDev() || !cache)) {
                      _context6.next = 16;
                      break;
                    }
                    _context6.t2 = resolve;
                    _context6.next = 12;
                    return renderServer(ctx, initProps, true);
                  case 12:
                    _context6.t3 = _context6.sent;
                    return _context6.abrupt("return", (0, _context6.t2)(_context6.t3));
                  case 16:
                    if (!_fs.existsSync(ssrCacheUrl)) {
                      _context6.next = 21;
                      break;
                    }
                    // ssr缓存模式，执行一次ssr 第二次直接返回缓存后的html静态资源
                    rs = _fs.createReadStream(ssrCacheUrl, 'utf-8');
                    return _context6.abrupt("return", resolve(rs));
                  case 21:
                    _context6.next = 23;
                    return renderServer(ctx, initProps, true);
                  case 23:
                    document = _context6.sent;
                    process.nextTick(function () {
                      (0, _common.writeCacheSsr)(ssrCacheDir, ssrCacheUrl, document); //异步写入服务器缓存目录
                    });
                    return _context6.abrupt("return", resolve(document));
                  case 26:
                  case "end":
                    return _context6.stop();
                }
              }, _callee6);
            }));
            return function (_x12) {
              return _ref7.apply(this, arguments);
            };
          }()));
        case 3:
        case "end":
          return _context7.stop();
      }
    }, _callee7);
  }));
  return function render(_x10, _x11) {
    return _ref6.apply(this, arguments);
  };
}();
exports.render = render;