"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendHTML = sendHTML;
var _etag = require("etag");
var _fresh = require("fresh");
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function sendHTML(ctx, html, _ref) {
  var generateEtags = _ref.generateEtags;
  var req = ctx.req,
    res = ctx.res;
  function isResSent(res) {
    return res.finished || res.headersSent;
  }
  if (isResSent(res)) return;
  if (_typeof(html) == 'object') {
    res.statusCode = 200;
    res.setHeader('Content-Type', 'text/html; charset=utf-8');
    ctx.body = html;
  } else {
    var etag = generateEtags ? _etag(html) : undefined;
    if (_fresh(req.headers, {
      etag: etag
    })) {
      res.statusCode = 304;
      res.end();
      return;
    }
    if (etag) {
      res.setHeader('ETag', etag);
    }
    res.statusCode = 200;
    res.setHeader('Content-Type', 'text/html; charset=utf-8');
    res.setHeader('Content-Length', Buffer.byteLength(html));
    res.end(req.method === 'HEAD' ? null : html);
  }
}